unit Crt2; (* Crt2 je unita s uitenmi funkcemi hlavn pro obrazovku
  a prci s etzci od Jakuba Vrny. Vechny texty, komente a pevodn
  tabulky jsou v kdovn brat Kamenickch. *)

interface (* Momentln by mly bt funkn vechny funkce a procedury krom
  WriteWrap (zbv dodlat), JeSoubor (zkontrolovat ppadn pedlat)
  a ReadIni (pedlat nebo odstranit). Zbytek proel testovnm. Poslednch
  devt funkc bude asi pesunuto do unity Dos2. *)
  uses Crt, Dos;

  const (* inicializovan promnn mnn pmo unitou *)
    stavInsert: boolean = true;
  const (* inicializovan promnn pouvan unitou *)
    zvyrAtr: byte = 12;
    nadpisAtr: byte = 11;
  var (* promnn uren pro poteby uivatele, kter unita nepotebuje *)
    i: byte;
    j: byte;
    k: word;
    l: word;
    f: text;
    g: text;
    ch: char;
    s: string;
    s2: string;
    cas: longint;
    datum: longint;
    konec: boolean;
    vypis: boolean;
    reg: registers;
    staryKurzor: word;
    year, month, day, dow: word;
    hour, minute, sec, s00: word;

  function SaveKurzor: word;
  function NastavKurzor (kurzor: word): word; (* Parametr funkce NastavKurzor
    a nvratov hodnoty kurzor funkc maj tvar hornLinkaKurzoru * 256
    + dolnLinkaKurzoru. *)
  function ZhasniKurzor: word;
  function RozniMalyKurzor: word;
  function RozniVelkyKurzor: word;

  procedure NastavRychlostKlavesnice (rychlost, opakovani: byte);
    (* Procedura NastavRychlostKlavesnice nastav rychlost klvesnice.
    Parametr rychlost se me pohybovat od 0 do 30 a uruje, kolik se nape
		znak za 1 sekundu, jestlie je klvesa drena a u od jejho prvnho
    stisku uplynul as symbolicky zadan jako opakovani. Parametr opakovani
    se me pohybovat od 0 do 3 a uruje dobu, po kter se stisknut klvesa
    zane opakovat. Hodnot 0 odpovd 1/4 s, 1 je 1/2 s, 2 je 3/4 s a 3 je
    1 s. Jen pro zajvavost: pepoet rychlosti do tvaru, kter vyaduje
    peruen $16 mi dal opravdu zabrat. Zkladn vzoreek pro vpoet
    nsledujcho lenu je (pravdpodobn): a(n+1) = a(n) / 2^(1/8). Nult
    len m hodnotu 30. Z toho plyne, e kterkoliv len je
    a(n) = 30/(2^(n/8)). Uf. *)
  procedure RychlaKlavesnice; (* Procedura RychlaKlavesnice nastav nejvy
    mon hodnoty pro rychlost a opakovn klvesnice. *)
  procedure NormalniKlavesnice; (* Procedura NormalniKlavesnice nastav
    hodnoty podle tch, kter jsou uloeny v Cmosu. *)

  function IntToStr (a: longint): string; (* Funkce IntToStr pevede zadan
    slo na etzec pomoc procedury Str. *)
  function StrToInt (s: string): longint; (* Funkce StrToInt pevede zadan
    etzec na slo pomoc procedury Val. *)

  procedure NastavPaletu (cisloBarvy, hodnotaBarvy: byte); (* Nastav barv
    cisloBarvy (0-15) hodnotaBarvy (0-63 podle rgbRGB - tedy na prvnch tech
    bitech zvis jednou tetinou, na poslednch dvmi tetinami. Nap. tmav
                erven je 111100, svtle zelen je 000010.). *)

  function WhereMaxX: byte;
  function WhereMaxY: byte; (* Funkce WhereMaxX a WhereMaxY vrt maximln
    obrazovkov souadnice *)

  procedure WriteXY (x, y: byte; s: string);
  procedure WriteAtr (s: string; atribut: byte);
  procedure WriteAtrLn (s: string; atribut: byte);
  procedure WriteXYAtr (x, y: byte; s: string; atribut: byte);

  procedure WriteZvyr (zvyrazneny, popis: string); (* Funkce WriteZvyr nape
    etzec zvyrazneny globlnm atributem zvyrAtr, mezeru a etzec s. *)
  procedure WriteZvyrLn (zvyrazneny, popis: string);
  procedure WriteNadpis (nadpis: string); (* Procedura WriteNadpis nape
    podtren text a pesune se na dal dek. *)
  procedure WriteZvyrNadpis (zvyrazneny, nadpis: string);

  procedure WriteWrap (retez: string); (* Procedura WriteWrap vype text
    tak, e ho na konci obrazovky rozdl na cel slova *)
  procedure WriteWrapLn (retez: string);

  procedure WriteMem (x, y: byte; s: string; atribut: byte); (* Procedura
		WriteMem zape do obrazovkov pamti etzec (stran rychle a natvrdo).
    Parametr x uruje horizontln souadnice, parametr y vertikln
    souadnice, s etzec uren k zapsn a atribut uruje atribut, kterm
    se to nape. Vpoet atributu je 128 * blikn + 16 * pozad + poped.
    Nap. bl psmo na ernm podkladu je 7. *)

  function WriteObdelnik (x1, y1, x2, y2, atribut: byte): boolean; (* Funkce
    WriteObdelnik nakresl obdelnk na obrazovku. Jestlie souadnice
    nevyhovuj, vrt se false. *)

  procedure ClsAtr (znak: char; atribut: byte); (* Procedura ClsAtr vymae
                okno zadanm znakem zadanho atributu pomoc pmho zpisu do pamti. *)
  procedure Cls; (* Procedura Cls pokryje okno znakem mezera s atributem
    svtle ed na ern pomoc procedury ClsAtr. *)

  function WaitKey: word; (* Funkce WaitKey ek na klvesu a vrac bu
    rozenKdKlvesy + 256 nebo asciiKdKlvesy. *)
  function ScanKey: word; (* Funkce ScanKey ek na klvesu a vrac
    stavPemyka * 256 + scanKdKlvesy. stavPemyka je slo, kter
    vyjde po soutu hodnot jednotlivch pemyka: 1 = prav Shift,
    2 = lev Shift, 4 = Ctrl, 8 = Alt, 16 = stav ScrollLock,
    32 = stav NumLock, 64 = stav CapsLock, 128 = stav Insert. Stavem se
    mysl zapnut pemyka. Chceme-li tedy napklad zjistit, byl-li
    stisknut shift je to: (ScanKey mod 256) mod 4 > 0. scanKdKlvesy
    piblin odpovd umstn klvesy na klvesnici. Nap. Q = 16, W = 17,
    E = 18, R = 19, atd. *)
  function ScanAnyKey: word; (* Funkce ScanAnyKey ek na klvesu a vrac
    stavPemyka * 256 + ascii-kd klvesy, m-li klvesa svj ascii-kd,
    nebo vrac 8192 + stavPemyka * 256 + scan-kd klvesy. stavPemyka
    zachycuje pouze Shift, Ctrl a Alt. *)

  function BezMezer (retez: string): string;
  function BezMezerNaZacatku (retez: string): string;
  function BezMezerNaKonci (retez: string): string;
  function JeMezeroidni (s: string): boolean; (* Funkce JeMezeroidni
    vrt true, jestlie prvn znak etzce v parametru je mezeroidn.
    Mezeroidn zahrnuje znaky: mezera, !"#$%&'()*+,-./:;<=>?@[\]^_`{|},
    ~ a #255. *)

  function JeVRetezciKde (retez, co: string; prvni: boolean): byte; (* Funkce
    JeVRetezciKde vrt pozici etzce co v etzci retez a to bu prvn
    nebo posledn v zvislosti na hodnot parametru prvni. Jestlie co nen
    v retez obsaen, vrt nulu. *)
  function JeVRetezci (retez, co: string): byte; (* JeVRetezci vrt
    pozici prvnho vskytu etzce co v etzci retez. Vol funkci
								JeVRetezciKde. *)
  function MeziZnaky (retez, uvodni, konecny: string): string; (* Funkce
    MeziZnaky vrt etzec, kter byl v etzci retez mezi prvnm etzcem
    uvodni a poslednm etzcem konecny. Vol funkci JeVRetezciKde. *)

  function ReadDefaultString (retez: string): string; (* Funkce
    ReadDefaultString inteligentn nate etzec a vrt ho. Inteligentn
    zahrnuje tyto monosti: pohyb kurzoru pomoc ipek vlevo a vpravo,
    mazn pomoc klves Delete a BackSpace, globln Insert (jeho nastaven
    se neztrat pi oputn funkce), Enter neposune kurzor na dal dek,
    pouze ukon zadvn, text nepetee pes prav okraj, dovol zadat
    pouze tisknuteln znaky, zadan parametr bude zobrazen jako implicitn,
    Esc zpsob vrcen implicitnho etzce, Ctrl-vlevo a Ctrl-vpravo
    posune kurzor o slovo, Ctrl-Y vymae dek, Ctrl-BackSpace vymae slovo
    ped kurzorem, Ctrl-T vymae slovo za kurzorem, Ctrl-QY vymae ve do
    konce dku. *)
  function ReadString: string; (* Funkce ReadString funguje stejn jako
    funkce ReadDefaultString (vol j), ale jako parametr je zadn przdn
    etzec. *)
  function ReadStringLn: string; (* Funkce ReadStringLn nate etzec
    stejn jako funkce ReadString, ale po naten sko na dal dek. *)

  function UpperCase (retez: string): string; (* Funkce UpperCase konvertuje
    etzec v parametru na velk psmena a to vetn etiny v kdovn
    brat Kamenickch. *)
  function LowerCase (retez: string): string; (* Funkce LowerCase konvertuje
    etzec v parametru na mal psmena a to vetn etiny v kdovn
    brat Kamenickch. *)
  function BezCestiny (retez: string): string; (* Funkce BezCestiny vrt
    retez v kdovn Kamenickch pevedn do cestiny. *)

  function Mocnina (zaklad: real; exponent: real): real; (* Funkce Mocnina
    vrt slo kter je exponentou mocninou zakladu. Um i odmocovat,
    jestlie se j zad jako exponent slo 1/odmocnitel. Mal pklad:
                Mocnina (2, 3): 8; Mocnina (3, 1): 3; Mocnina (4, 1/2): 2. *)
  function Faktorial (parametr: byte): longint; (* Funkce Faktorial vrt
    slo parametr!. *)

  function KolikJe: longint; (* Funkce KolikJe vrt slo, ve kterm je
    uloen aktuln as (poet setin sekundy od zatku dne). Slou
    hlavn na zmen toho, jak nco dlouho trvalo. *)
  function KolikatehoJe: longint; (* Funkce KolikatehoJe vrt slo, ve
    kterm je uloeno aktuln datum (poet dn v naem letopotu). *)

  function PocetDni (mesic: word; rok: word): byte; (* Funkce PocetDni vrt
		poet dn v msci v zadanm roce (parametry jsou typu word, aby se
    rovnou daly pout vsledky funkce GetDate). *)
  function PocetDniTed: byte; (* Funkce PocetDniTed vrt poet dn
    v momentlnm msci *)

  function JeSoubor (soubor: string): boolean;

  function ReadIni (iniSoubor, sekce, polozka: string): string;
  function ReadIniWord (iniSoubor, sekce, polozka: string): word;

implementation
function SaveKurzor: word;
  var
    kurzor: word absolute $40:$60;
  begin
    SaveKurzor:= kurzor;
    end;

function NastavKurzor (kurzor: word): word;
  var
    reg: registers;
  begin
    NastavKurzor:= SaveKurzor;
                reg.ah:= 1;
    reg.ch:= kurzor div 256;
    reg.cl:= kurzor mod 256;
    Intr ($10, reg);
    end;

function ZhasniKurzor: word;
  begin
    ZhasniKurzor:= NastavKurzor (32 * 256 + 7);
    end;

function RozniMalyKurzor: word;
  begin
    RozniMalyKurzor:= NastavKurzor (6 * 256 + 7);
    end;

function RozniVelkyKurzor: word;
  begin
    RozniVelkyKurzor:= NastavKurzor (0 * 256 + 7);
    end;

procedure NastavRychlostKlavesnice (rychlost: byte; opakovani: byte);
	var
    reg: registers;
  begin
    reg.ah:= 3;
    if rychlost = 0 then
      reg.al:= 4
    else begin
      reg.al:= 5;
      reg.bl:= Round (8 * Ln (30 / rychlost) / Ln (2));
      reg.bh:= opakovani;
      end;
    Intr ($16, reg);
                end;

procedure RychlaKlavesnice;
  begin
    NastavRychlostKlavesnice (30, 0);
    end;

procedure NormalniKlavesnice;
	var
		reg: registers;
	begin
		reg.ah:= 3;
		reg.al:= 0;
		Intr ($16, reg);
		end;

function IntToStr (a: longint): string;
	var
		s: string;
	begin
		Str (a, s);
		IntToStr:= s;
		end;

function StrToInt (s: string): longint;
	var
		a: longint;
		code: integer;
	begin
		Val (s, a, code);
		StrToInt:= a;
		end;

procedure NastavPaletu (cisloBarvy, hodnotaBarvy: byte);
	var
    reg: registers;
  begin
    reg.ah:= $10;
    reg.al:= 0;
    reg.bl:= cisloBarvy;
    reg.bh:= hodnotaBarvy;
    Intr ($10, reg);
    end;

function WhereMaxX: byte;
  var
    maxX: byte absolute $40:$4a;
  begin
    WhereMaxX:= maxX;
    end;

function WhereMaxY: byte;
  var
		maxY: byte absolute $40:$84;
  begin
    WhereMaxY:= maxY + 1;
    end;

procedure WriteXY (x, y: byte; s: string);
  begin
    GotoXY (x, y);
    Write (s);
    end;

procedure WriteAtr (s: string; atribut: byte);
  begin
    TextColor (atribut);
    Write (s);
		NormVideo;
		end;

procedure WriteAtrLn (s: string; atribut: byte);
	begin
		TextColor (atribut);
		Write (s);
		NormVideo;
		WriteLn;
		end;

procedure WriteXYAtr (x, y: byte; s: string; atribut: byte);
	begin
		GotoXY (x, y);
		TextColor (atribut);
		Write (s);
		NormVideo;
		end;

procedure WriteZvyr (zvyrazneny, popis: string);
	begin
		WriteAtr (zvyrazneny, zvyrAtr);
		Write (' ', popis);
		end;

procedure WriteZvyrLn (zvyrazneny, popis: string);
	begin
		WriteZvyr (zvyrazneny, popis);
		WriteLn;
		end;

procedure WriteNadpis (nadpis: string);
	var
		i: byte;
				begin
		WriteAtrLn (nadpis, nadpisAtr);
		for i:= 1 to Length (nadpis) do WriteAtr ('-', nadpisAtr);
		WriteLn;
		end;

procedure WriteZvyrNadpis (zvyrazneny, nadpis: string);
	var
		i: byte;
	begin
		WriteAtr (zvyrazneny + ' ', zvyrAtr);
		WriteAtrLn (nadpis, nadpisAtr);
		for i:= 0 to Length (zvyrazneny + nadpis) do WriteAtr ('-', nadpisAtr);
		WriteLn;
		end;

procedure WriteWrap (retez: string);
	var
		i: byte;
		s: string;
		zlom: byte;
		maxX: byte;
	begin
		if retez <> '' then begin (* pro przdn etzec se nic nestane *)
			maxX:= Lo (windMax) - Lo (windMin);
			s:= retez;
			if WhereX = maxX then WriteLn; (* kdy je kurzor na kraji dku, nic u
				se tam nenape *)
			zlom:= maxX - WhereX;
			while Length (s) > zlom do begin (* dokud m jet cenu zalamovat *)
				if (not JeMezeroidni (s [zlom])) or (JeMezeroidni (s [zlom + 1]))
					then begin (* jinak nastane ideln situace *)
					i:= zlom;
					while (i > 1) and (JeMezeroidni (s [i])) do (* dojdeme na posledn
						nemezeroidn znak ped zlomem *)
						Dec (i);
					if i > 1 then repeat (* dojdeme tsn ped toto slovo *)
						Dec (i);
						until (JeMezeroidni (s [i])) or (i = 1);
					if i > 1 then zlom:= i (* pozitivn, nedoli jsme na zatek *)
					else begin (* zkusme, jestli by se to nevelo na cel dek *)
						i:= zlom;
						while (i < maxX - 1) (* odeten 1 je pozice na celm dku *)
							and (i < Length (s)) and (not JeMezeroidni (s [i])) do
							Inc (i); (* peskome vechna psmenka *)
						if JeMezeroidni (s [i]) then Inc (i);
						while (i < maxX - 1) (* odeten 1 je pozice na celm dku *)
							and (i < Length (s)) and (JeMezeroidni (s [i])) do
							Inc (i);
						if not JeMezeroidni (s [i]) then zlom:= 0; (* vylo to *)
						end;
					end;
				WriteLn (Copy (s, 1, zlom));
				s:= Copy (s, zlom + 1, Length (s) - zlom + 1);
				zlom:= maxX - WhereX;
				end;
			Write (s);
			end;
		end;

procedure WriteWrapLn (retez: string);
	begin
		WriteWrap (retez);
		WriteLn;
		end;

procedure WriteMem (x: byte; y: byte; s: string; atribut: byte);
	type
		tPoleZnaku = array [0..511] of char;
	var
		i: byte;
		segment: word;
		ofset: word absolute $40:$4e;
		mode: byte absolute $40:$49;
		poleZnaku: ^tPoleZnaku;
	begin
		case mode of
			0..3: segment:= $b800;
			7: segment:= $b000;
			end;
		poleZnaku:= Ptr (segment, ofset + 2*((x-1) + (y-1) * WhereMaxX));
		for i:= 1 to Length (s) do begin
			poleZnaku^ [2*i-2]:= s [i];
			poleZnaku^ [2*i-1]:= Chr (atribut);
			end;
		end;

function WriteObdelnik (x1, y1, x2, y2, atribut: byte): boolean;
	var
		i: byte;
	begin
		WriteObdelnik:= false;
		if (x1 > 0) and (y1 > 0) and (x2 <= WhereMaxX) and (y2 <= WhereMaxY) then
			begin
			WriteObdelnik:= true;
			WriteMem (x1, y1, #218, atribut);
			for i:= x1 + 1 to x2 - 1 do
				WriteMem (i, y1, #196, atribut);
			WriteMem (x2, y1, #191, atribut);
			for i:= y1 + 1 to y2 - 1 do begin
				WriteMem (x1, i, #179, atribut);
        WriteMem (x2, i, #179, atribut);
                                end;
      WriteMem (x1, y2, #192, atribut);
      for i:= x1 + 1 to x2 - 1 do
        WriteMem (i, y2, #196, atribut);
      WriteMem (x2, y2, #217, atribut);
      end;
    end;

procedure ClsAtr (znak: char; atribut: byte);
  var
    i: byte;
    j: byte;
  begin
    for j:= Hi (windMin) to Hi (windMax) - Hi (windMin) + 1 do
      for i:= Lo (windMin) to Lo (windMax) - Lo (windMin) + 1 do
        WriteMem (i, j, znak, atribut);
    GotoXY (1, 1);
    end;

procedure Cls;
  begin
    ClsAtr (' ', 7);
    end;

function WaitKey: word;
  var
    reg: registers;
  begin
    reg.ah:= 8;
    MsDos (reg);
                if reg.al = 0 then begin
                        Msdos (reg);
                        WaitKey:= reg.al + 256;
                        end
                else WaitKey:= reg.al;
                end;

function ScanKey: word;
        var
                shiftKod: byte;
                scanKod: byte;
                reg: registers;
        begin
                reg.ah:= $10;
                Intr ($16, reg);
                scanKod:= reg.ah;
                reg.ah:= $02;
                Intr ($16, reg);
                shiftKod:= reg.al;
                ScanKey:= shiftKod * 256 + scanKod;
                end;

function ScanAnyKey: word;
        var
                shiftKod: byte;
                kodKlavesy: word;
                reg: registers;
        begin
                reg.ah:= $10;
                Intr ($16, reg);
                case reg.al of
                        0..31: kodKlavesy:= reg.ah + 8192;
                        else kodKlavesy:= reg.al;
                        end;
                reg.ah:= 2;
                Intr ($16, reg);
                shiftKod:= reg.al mod 16;
                ScanAnyKey:= shiftKod * 256 + kodKlavesy;
                end;

function BezMezer (retez: string): string;
        var
                i: byte;
                s: string;
        begin
                s:= '';
                for i:= 1 to Length (retez) do
                        if retez [i] <> ' ' then
                                s:= s + retez [i];
                BezMezer:= s;
                end;

function BezMezerNaZacatku (retez: string): string;
        var
                i: byte;
        begin
                i:= 1;
                while (retez [i] = ' ') do
                        Inc (i);
                BezMezerNaZacatku:= Copy (retez, i, Length (retez) + 1 - i);
                end;

function BezMezerNaKonci (retez: string): string;
        var
                s: string;
                i: byte;
                konec: boolean;
        begin
                s:= retez;
                konec:= false;
                i:= Length (s);
                while (i > 0) and (not konec) do begin
                        if s [i] = ' ' then s:= Copy (s, 1, Length (s) - 1)
                        else konec:= true;
                        Dec (i);
                        end;
                BezMezerNaKonci:= s;
                end;

function JeMezeroidni (s: string): boolean;
        begin
                if ((s >= #32) and (s <= #47)) or ((s >= #58) and (s <= #64))
                        or ((s >= #91) and (s <= #96)) or ((s >= #123) and (s <= #126))
                        or ((s >= #174) and (s <= #175)) or ((s >= #237) and (s <= #255))
                        then JeMezeroidni:= true
                else JeMezeroidni:= false;
                end;

function JeVRetezciKde (retez, co: string; prvni: boolean): byte;
        var
                i: byte;
                j: byte;
                konec: boolean;
                konec2: boolean;
        begin
                JeVRetezciKde:= 0;
                if Length (retez) >= Length (co) then begin
                        konec:= false;
                        i:= 0;
                        while (i < Length (retez) - Length (co) + 1)
                                and (not (konec and prvni)) do begin
                                Inc (i);
                                konec2:= false;
                                j:= 0;
                                while (j < Length (co)) and (not konec2) do begin
                                        if retez [i + j] <> co [j + 1] then konec2:= true;
                                        Inc (j);
          end;
        if not konec2 then begin
          konec:= true;
          JeVRetezciKde:= i;
          end;
        end;
      end;
    end;

function JeVRetezci (retez, co: string): byte;
  begin
    JevRetezci:= JeVRetezciKde (retez, co, true);
    end;

function MeziZnaky (retez, uvodni, konecny: string): string;
  var
    prvni: byte;
    posledni: byte;
  begin
    prvni:= JeVRetezciKde (retez, uvodni, true);
    posledni:= JeVRetezciKde (retez, konecny, false);
    if (prvni <> 0) and (posledni <> 0) then
      if uvodni <> '' then
        if konecny <> '' then
          MeziZnaky:= Copy (retez, prvni + Length (uvodni),
            posledni - prvni - Length (uvodni))
        else MeziZnaky:= Copy (retez, prvni + Length (uvodni),
          posledni - prvni - Length (uvodni) + 1)
      else
        if konecny <> '' then
          MeziZnaky:= Copy (retez, prvni, posledni - prvni)
        else MeziZnaky:= Copy (retez, prvni, posledni - prvni + 1)
    else MeziZnaky:= '';
                end;

function ReadDefaultString (retez: string): string;
  var
    k: word;
    s: string;
    maxX: byte;
    pozice: byte;
    konec: boolean;
    staryKurzor: word;

  procedure DeleteKey;
    begin
      if pozice <= Length (s) then begin
        s:= Copy (s, 1, pozice - 1) + Copy (s, pozice + 1, Length (s));
        Write (Copy (s, pozice, Length (s)));
        ClrEol;
        GotoXY (WhereX - Length (s) + pozice - 1, WhereY);
        end;
      end;

  procedure BackSpaceKey;
    begin
      if pozice > 1 then begin
        Dec (pozice);
        s:= Copy (s, 1, pozice - 1) + Copy (s, pozice + 1, Length (s));
        GotoXY (WhereX - 1, WhereY);
        Write (Copy (s, pozice, Length (s)));
        ClrEol;
        GotoXY (WhereX - Length (s) + pozice - 1, WhereY);
        end;
      end;

  procedure CtrlKKey;
                begin

      end;

  procedure EnterKey;
    begin
      konec:= true;
      end;

  procedure CtrlQKey;
    procedure CtrlQYKey;
      begin
        while pozice <= Length (s) do
          DeleteKey;
        end;
    begin
      k:= WaitKey;
      case k of
        25, 89, 121: CtrlQYKey;
        end;
      end;

  procedure CtrlTKey;
    begin
      if pozice <= Length (s) then begin
        if (JeMezeroidni (s [pozice]))
          and (not JeMezeroidni (s [pozice + 1])) then
          DeleteKey
        else begin
          while (not JeMezeroidni (s [pozice]))
            and (pozice <= Length (s)) do
            DeleteKey;
          while (JeMezeroidni (s [pozice]))
            and (pozice <= Length (s)) do
                                                DeleteKey;
          end;
        end;
      end;

  procedure CtrlYKey;
    begin
      GotoXY (WhereX - pozice + 1, WhereY);
      ClrEol;
      pozice:= 1;
      s:= '';
      end;

  procedure EscapeKey;
    begin
      konec:= true;
      s:= retez;
      end;

  procedure CtrlBackSpaceKey;
    begin
      if pozice > 1 then
        if (JeMezeroidni (s [pozice - 1]))
          and (not JeMezeroidni (s [pozice - 2]))
          and (pozice > 2) then
          BackSpaceKey
        else begin
          while (not JeMezeroidni (s [pozice - 1]))
            and (pozice > 1) do
            BackSpaceKey;
          while (JeMezeroidni (s [pozice - 1]))
            and (pozice > 1) do
            BackSpaceKey;
          end;
                        end;

  procedure ZadejZnak;
    begin
      if WhereX + Length (s) - pozice < maxX then begin
        case stavInsert of
          true: s:= Copy (s, 1, pozice - 1) + Chr (k)
            + Copy (s, pozice, Length (s));
          false: s:= Copy (s, 1, pozice - 1) + Chr (k)
            + Copy (s, pozice + 1, Length (s));
          end;
        Write (Copy (s, pozice, Length (s)));
        ClrEol;
        GotoXY (WhereX - Length (s) + pozice, WhereY);
        Inc (pozice);
        end;
      end;

  procedure HomeKey;
    begin
      GotoXY (WhereX - pozice + 1, WhereY);
      pozice:= 1;
      end;

  procedure VlevoKey;
    begin
      if pozice > 1 then begin
        Dec (pozice);
        GotoXY (WhereX - 1, WhereY);
        end;
      end;

  procedure VpravoKey;
    begin
                        if pozice <= Length (s) then begin
        Inc (pozice);
        GotoXY (WhereX + 1, WhereY);
        end;
      end;

  procedure EndKey;
    begin
      GotoXY (WhereX - pozice + Length (s) + 1, WhereY);
      pozice:= Length (s) + 1;
      end;

  procedure InsertKey;
    begin
      stavInsert:= not stavInsert;
      end;

  procedure CtrlVlevoKey;
    begin
      if pozice > 1 then begin
        VlevoKey;
        if (JeMezeroidni (s [pozice]))
          or (not JeMezeroidni (s [pozice - 1])) then begin
          while (JeMezeroidni (s [pozice - 1]))
            and (pozice > 1) do
            VlevoKey;
          while (not JeMezeroidni (s [pozice - 1]))
            and (pozice > 1) do
            VlevoKey;
          end;
        end;
      end;

  procedure CtrlVpravoKey;
                begin
      if pozice <= Length (s) then begin
        VpravoKey;
        if (JeMezeroidni (s [pozice]))
          or (not JeMezeroidni (s [pozice - 1])) then begin
          while (not JeMezeroidni (s [pozice])) and
            (pozice <= Length (s)) do
            VpravoKey;
          while (JeMezeroidni (s [pozice])) and
            (pozice <= Length (s)) do
            VpravoKey;
          end;
        end;
      end;

  begin
    maxX:= Lo (windMax) - Lo (windMin);
    konec:= false;
    pozice:= 1;
    s:= retez;
    if stavInsert then staryKurzor:= RozniMalyKurzor
    else staryKurzor:= RozniVelkyKurzor;
    Write (s);
    pozice:= Length (s) + 1;
    ClrEol;
    repeat
      k:= WaitKey;
      ZhasniKurzor;
      case k of
        8: BackSpaceKey;
        11: CtrlKKey;
        13: EnterKey;
        17: CtrlQKey;
        20: CtrlTKey;
                                25: CtrlYKey;
        27: EscapeKey;
        127: CtrlBackSpaceKey;
        32..126, 128..255: ZadejZnak;
        327: HomeKey;
        331: VlevoKey;
        333: VpravoKey;
        335: EndKey;
        338: InsertKey;
        339: DeleteKey;
        371: CtrlVlevoKey;
        372: CtrlVpravoKey;
        end;
      if stavInsert then RozniMalyKurzor
      else RozniVelkyKurzor;
      until konec;
    ReadDefaultString:= s;
    GotoXY (WhereX - pozice + Length (s) + 1, WhereY);
    NastavKurzor (staryKurzor);
    end;

function ReadString: string;
  begin
    ReadString:= ReadDefaultString ('');
    end;

function ReadStringLn: string;
  begin
    ReadStringLn:= ReadDefaultString ('');
    WriteLn;
    end;

function UpperCase (retez: string): string;
  var
                s: string;
    i: byte;
  begin
    s:= '';
    for i:= 1 to Length (retez) do
      case Ord (retez [i]) of
        97..122: s:= s + Chr (Ord (retez [i]) - 32);
        129: s:= s + Chr (154);
        130: s:= s + Chr (144);
        131: s:= s + Chr (133);
        132: s:= s + Chr (142);
        135: s:= s + Chr (128);
        136: s:= s + Chr (137);
        140: s:= s + Chr (156);
        141: s:= s + Chr (138);
        145: s:= s + Chr (146);
        147: s:= s + Chr (167);
        148: s:= s + Chr (153);
        150: s:= s + Chr (166);
        152: s:= s + Chr (157);
        159: s:= s + Chr (134);
        160: s:= s + Chr (143);
        161: s:= s + Chr (139);
        162: s:= s + Chr (149);
        163: s:= s + Chr (151);
        164: s:= s + Chr (165);
        168: s:= s + Chr (155);
        169: s:= s + Chr (158);
        170: s:= s + Chr (171);
        else s:= s + retez [i];
        end;
    UpperCase:= s;
    end;

function LowerCase (retez: string): string;
  var
    s: string;
    i: byte;
  begin
    s:= '';
    for i:= 1 to Length (retez) do
      case Ord (retez [i]) of
        65..90: s:= s + Chr (Ord (retez [i]) + 32);
        128: s:= s + Chr (135);
        133: s:= s + Chr (131);
        134: s:= s + Chr (159);
        137: s:= s + Chr (136);
        138: s:= s + Chr (141);
        139: s:= s + Chr (161);
        142: s:= s + Chr (132);
        143: s:= s + Chr (160);
        144: s:= s + Chr (130);
        146: s:= s + Chr (145);
        149: s:= s + Chr (162);
        151: s:= s + Chr (163);
        153: s:= s + Chr (148);
        154: s:= s + Chr (129);
        155: s:= s + Chr (168);
        156: s:= s + Chr (140);
        157: s:= s + Chr (152);
        158: s:= s + Chr (169);
        165: s:= s + Chr (164);
        166: s:= s + Chr (150);
        167: s:= s + Chr (147);
        171: s:= s + Chr (170);
        else s:= s + retez [i];
        end;
    LowerCase:= s;
                end;

function BezCestiny (retez: string): string;
  var
    i: byte;
    s: string;
  begin
    s:= '';
    for i:= 1 to Length (retez) do
      case Ord (retez [i]) of
        128: s:= s + 'C';
        129: s:= s + 'u';
        130: s:= s + 'e';
        131: s:= s + 'd';
        132: s:= s + 'a';
        133: s:= s + 'D';
        134: s:= s + 'T';
        135: s:= s + 'c';
        136: s:= s + 'e';
        137: s:= s + 'E';
        138: s:= s + 'L';
        139: s:= s + 'I';
        140: s:= s + 'l';
        141: s:= s + 'l';
        142: s:= s + 'A';
        143: s:= s + 'A';
        144: s:= s + 'E';
        145: s:= s + 'z';
        146: s:= s + 'Z';
        147: s:= s + 'o';
        148: s:= s + 'o';
        149: s:= s + 'O';
        150: s:= s + 'u';
        151: s:= s + 'U';
                                152: s:= s + 'y';
        153: s:= s + 'O';
        154: s:= s + 'U';
        155: s:= s + 'S';
        156: s:= s + 'L';
        157: s:= s + 'Y';
        158: s:= s + 'R';
        159: s:= s + 't';
        160: s:= s + 'a';
        161: s:= s + 'i';
        162: s:= s + 'o';
        163: s:= s + 'u';
        164: s:= s + 'n';
        165: s:= s + 'N';
        166: s:= s + 'U';
        167: s:= s + 'O';
        168: s:= s + 's';
        169: s:= s + 'r';
        170: s:= s + 'r';
        171: s:= s + 'R';
        else s:= s + retez [i];
        end;
    BezCestiny:= s;
    end;

function Mocnina (zaklad: real; exponent: real): real;
  begin
    Mocnina:= Exp (exponent * ln (zaklad));
    end;

function Faktorial (parametr: byte): longint;
  var
    i: byte;
    vysledek: longint;
        begin
    vysledek:= 1;
    if parametr <> 0 then
      for i:= 1 to parametr do vysledek:= vysledek * i;
    Faktorial:= vysledek;
    end;

function KolikJe: longint;
  var
    hour, min, sec, s00: word;
  begin
    GetTime (hour, min, sec, s00);
    KolikJe:= 60*60*100*hour + 60*100*min + 100*sec + s00;
    end;

function KolikatehoJe: longint;
  var
    year, month, day, dow: word;
  begin
    GetDate (year, month, day, dow);
    KolikatehoJe:= 31*12*year + 31*month + day;
    end;

function PocetDni (mesic: word; rok: word): byte;
  begin
    case mesic of
      4, 6, 9, 11: PocetDni:= 30;
      2: if (rok mod 4 = 0) and (rok mod 100 <> 0) then PocetDni:= 29
        else PocetDni:= 28;
      else PocetDni:= 31
      end;
    end;

function PocetDniTed: byte;
  var
    year, month, day, dow: word;
  begin
    GetDate (year, month, day, dow);
    PocetDniTed:= PocetDni (month, year);
    end;

function JeSoubor (soubor: string): boolean;
  var
    f: file;
  begin
    {$I-}
    Assign (f, soubor);
    Reset (f);
    Close (f);
    {$I+}
    JeSoubor:= (IOResult = 0) and (soubor <> '');
    end;

function ReadIni (iniSoubor, sekce, polozka: string): string;
  var
    f: text;
    s: string;
    konec: boolean;
  begin
    ReadIni:= '';
    {$I-}
    Assign (f, iniSoubor);
    Reset (f);
    {$I+}
    if IOResult = 0 then begin
      konec:= false;
      while (not Eof (f)) and (not konec) do begin
        ReadLn (f, s);
        if UpperCase (BezMezer (MeziZnaky (s, '[', ']')))
          = UpperCase (BezMezer (sekce)) then begin
          repeat
            ReadLn (f, s);
            if UpperCase (BezMezer (polozka))
              = UpperCase (BezMezer (MeziZnaky (s, '', '='))) then begin
              if JeVRetezciKde (s, ';', false) > JeVRetezci (s, '=') then
                ReadIni:= BezMezerNaZacatku (BezMezerNaKonci
                  (MeziZnaky (s, '=', ';')))
              else ReadIni:= BezMezerNaZacatku (BezMezerNaKonci
                (MeziZnaky (s, '=', '')));
              konec:= true;
              end;
            until (Eof (f)) or (JeVRetezci (s, '[') <> 0);
          end;
        end;
      Close (f);
      end;
    end;

function ReadIniWord (iniSoubor, sekce, polozka: string): word;
  begin
    ReadIniWord:= StrToInt (ReadIni (iniSoubor, sekce, polozka));
    end;

end.
